 <?php
//call the FPDF library
//require('fpdf181/fpdf.php');
$this->load->library('Fpdf_Master');

//$today = date('Y-m-d'));
//A4 width : 219mm
//default margin : 10mm each side
//writable horizontal : 219-(10*2)=189mm

//$tt =  $user;
//class PDF_sample extends FPDF

$data= '';   

class PDF_sample extends FPDF {
  
  	private $data = array();
  	private $inv = array();
  	private $inv_itm = array();
  	private $tm = array();
  	private $options = array(
  		'inv' => '',
  		'destinationfile' => '',
  		'paper_size'=>'F4',
  		'orientation'=>'P'
  	);
  	
  	function __construct($data = array(), $options = array(),$inv = array(),$inv_itm = array(),$tm = array()) {
    	parent::__construct();
    	$this->data = $data;
    	$this->inv = $inv;
    	$this->inv_itm = $inv_itm;
    	$this->options = $options;
    	$this->tm = $tm;
	}
	

	
	function Footer()
{
    // Go to 1.5 cm from bottom
   
    $this->SetY(-15);
    
//	$this->Image('assets/images/meslogo.png',8,10,-300);  //$this->Image('img/cargologo.jpg',15,890,40,40);
//	$this->Image('img/cargologo.jpg',15,540,50,50);
	 
	 //$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(5 ,-3,'CREATED USER & DATE : ' .$this->inv[0]->co_cuser.' / '.$this->inv[0]->co_cdate,0,0);//end of line
$this->Cell(5 ,5,$this->inv[0]->co_euser,0,0);//end of line

   $this->SetFont('Arial','',7);
	 
	$this->SetX(0); $this->Cell(0, 10, $this->tm[1][0]->pro_fslogans, 0, 0,'C');
	$this->Ln(2);
	$this->SetX(0); $this->Cell(0, 12, $this->tm[1][0]->pro_sfslogans, 0, 0,'C');
    // Select Arial italic 8
    $this->SetFont('Arial','',7);
	
    // Print centered page number
    //$this->Cell(0,10,'Page '.$this->PageNo(),0,0,'R');
    $this->Cell(0,10,'Page '.$this->PageNo().' of {nb}',0,0,'C');
     $this->Line(18,283,205,283);
	
}
	
	public function rptDetailData () {
		
		//
		$border = 0;
		$this->AddPage();
		$this->SetAutoPageBreak(False);
		$this->AliasNbPages();
		$left = 18;
		$left1 = 5;
		//$left = 15;
		
		
	$this->SetLeftMargin($left);

		 // Logo
    $this->Image('assets/images/meslogo.png',18,31,-300);
    // Arial bold 15
    $this->SetFont('Arial','B',16);
    // Move to the right
    $this->Cell(77);
    // Title
    $this->Cell(111,10,$this->tm[1][0]->pro_name,0,0,'R');
     $this->Ln(7);
     
     $this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(111,10,$this->tm[1][0]->pro_add,0,0,'R');
   
     
    $this->Ln(4);
     $this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(111,10,$this->tm[1][0]->pro_num,0,0,'R');
    
    $this->Ln(4);
     $this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(111,10,$this->tm[1][0]->pro_email,0,0,'R');
     $this->Ln(4);
     $this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(111,10,$this->tm[1][0]->pro_web,0,0,'R');
     $this->Ln(6);
    
     $this->Cell(77);
     $this->SetFont('Arial','B',10);
    $this->Cell(111,10,"Company Reg.No:".$this->tm[1][0]->pro_reg,0,0,'R');
    // Line break
    $this->Ln(12);
   $this->Line(18,43,205,43); 
   
$this->SetFont('Arial','B',12);	
$this->Cell(149 ,5,'INVOICE',0,1,'R');//end of line

//set font to arial, regular, 12pt
$this->SetFont('Arial','B',10);

if($this->inv[0]->cust_type=="Foreign"){$sup = "CUSTOMER"; $sref = "CUSTOMER REF.No.";}else{$sup = "CUSTOMER";$sref = "CUSTOMER REF.No.";}

//bill end
$this->Cell(1 ,4,$sup,0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
$this->Cell(59 ,4,'',0,1);//end of line

$repcom = strtoupper(stripslashes($this->inv[0]->cust_company));
$repcom = iconv('UTF-8', 'windows-1252', $repcom);

$podt = date("d-M-Y", strtotime($this->inv[0]->co_cdate));
$this->SetFont('Arial','',8);
$this->Cell(130 ,4,$repcom,0,0);
$this->Cell(33 ,4,'DATE',0,0);
$this->Cell(34 ,4,': '.strtoupper($podt),0,1);//end of line

$repad = strtoupper(stripslashes($this->inv[0]->cust_addres));
$repad = iconv('UTF-8', 'windows-1252', $repad);

$repad1 = strtoupper(stripslashes($this->inv[0]->cust_add1));
$repad1 = iconv('UTF-8', 'windows-1252', $repad1);

$repad2 = strtoupper(stripslashes($this->inv[0]->cust_add2));
$repad2 = iconv('UTF-8', 'windows-1252', $repad2);

$this->Cell(130 ,4, $repad ,0,0);
$this->Cell(33 ,4,'CUSTOMER ORDER No.',0,0);
$this->Cell(34 ,4,': '.$this->inv[0]->co_code.$this->inv[0]->co_id,0,1);//end of line

//$this->Cell(130 ,5,strtoupper($this->inv[0]->cnty_name)  ,0,0);

$this->Cell(130 ,4,strtoupper($repad1)  ,0,0);
$this->Cell(33 ,4,'Quotation.No.',0,0);
$this->Cell(40 ,4,': QTN'.$this->inv[0]->co_qto_refno,0,1);//end of line


$this->Cell(130 ,4,strtoupper($repad2) ,0,0);
$this->SetFont('Arial','',8);
$this->Cell(33 ,4,$sref,0,0);
$this->Cell(40 ,4,': '.$this->inv[0]->co_qto_id,0,1);//end of line

$this->Cell(130 ,4,strtoupper($this->inv[0]->cnty_name),0,1);
$this->SetFont('Arial','',8);

/*$this->Ln(1);
$this->SetFont('Arial','B',10);
$this->Cell(130 ,4,'DELIVERY ADDRESS' ,0,1);
$this->SetFont('Arial','',8);


$this->Cell(130 ,4,strtoupper($this->tm[1][0]->pro_deladd) ,0,0);
$this->SetFont('Arial','',8);
$this->Cell(25 ,4,'',0,0);
$this->Cell(34 ,4,'',0,1);//end of line
*/

//make a dummy empty cell as a vertical spacer
//$this->Cell(40 ,10,'',0,1);//end of line

$this->Ln(5);
		
		$h = 5;
		$left = 40;
		$top = 10;	
		#tableheader
		$this->SetFillColor(200,200,200);	
		$left = $this->GetX();
		$this->SetFont("Arial", "B", 8);
		$this->Cell(15,$h,'QTN',1,0,'C',true);
		$this->SetX($left += 15); $this->Cell(18, $h, 'ID', 1, 0, 'C',true);
		$this->SetX($left += 18); $this->Cell(15, $h, 'QTY', 1, 0, 'C',true);
		$this->SetX($left += 15); $this->Cell(10, $h, 'UNIT', 1, 0, 'C',true);		
		$this->SetX($left += 10); $this->Cell(72, $h, 'DESCRIPTION', 1, 0, 'C',true);
		$this->SetX($left += 72); $this->Cell(28, $h, 'RATE('.$this->inv[0]->curr_symble.')', 1, 0, 'C',true);
		$this->SetX($left += 28); $this->Cell(28, $h, 'AMOUNT('.$this->inv[0]->curr_symble.')', 1, 1, 'C',true);

		//$this->Ln(20);
		
		$this->SetFont('Arial','',9);
		$this->SetWidths(array(15,18,15,10,72,28,28));
		$this->SetAligns(array('C','L','R','C','L','R','R'));
		//$this->SetFontStyle(array('B','B','B','B','B','B','B','B'));
		$no = 1; $this->SetFillColor(255);

		$i=0;
        $total=0;
        $itmcount=0;
        
        foreach ($this->inv_itm as $post)   { 
            //if($post->serv_name!=""){$itm_name = $post->serv_name;
            //}else{$itm_name = $post->brand_name." ".$post->itm_name.$post->serv_name."\n".$post->part_no."\n".$post->model_name;}
            
            $this->Row(

            array('QTN'.$post[7],
            $post[0].'-'.$post[1], 
            $post[5], 
			$post[3],
			$post[2], 
			number_format(($post[4]),2,".",","),                                                                                        
            number_format(($post[4] * $post[5]),2,".",",")
          ));
          
          $i= $i+1;
        $total = $total + ($post[4] * $post[5]);
       // $total = number_format(($totalold),2,".",",");
            $itmcount = $itmcount+$post[4];
        }
        
        $this->Ln(5);
//summary
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'SUB TOTAL',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($total,2),1,1,'R');//end of line

$dd = ($this->inv[0]->co_discount * 100)/$total;
$dispre = number_format((float)$dd, 2, '.', '');

$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'DISCOUNT '.$dispre.'%',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line
$divd = ($total-($this->inv[0]->co_discount));

$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'NET TOTAL',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($total-$this->inv[0]->co_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line

$divd = ($total-($this->inv[0]->co_discount));

$taxspre = ($this->inv[0]->co_tax * $divd)/100 ;

if($this->inv[0]->co_tax!="0.00" ){

$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'TAX '.$this->inv[0]->co_tax.'%',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format(round($taxspre,2),2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line

}

if($this->inv[0]->co_nbt!=0.00){
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'NBT 3%',0,0);
$this->Cell(20 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(30 ,5,number_format($this->inv[0]->co_nbt,2),1,1,'R');//end of line
    
}

if($this->inv[0]->co_vat!=0.00){
    
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'VAT 12%',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_vat,2),1,1,'R');//end of line
}

if($this->inv[0]->co_trnceport!=0.00){
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'TRANSPORT FEE',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28,5,number_format($this->inv[0]->co_trnceport,2),1,1,'R');//end of line
}

if($this->inv[0]->co_banking!=0.00){
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'BANK FEE',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_banking,2),1,1,'R');//end of line
}

if($this->inv[0]->co_shipping!=0.00){
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'SHIPPING & HANDLING',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_shipping,2),1,1,'R');//end of line
    
}

if($this->inv[0]->co_other!=0.00){
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'OTHER FEE',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_other,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line

}



$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'TOTAL',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($this->inv[0]->co_final_tot,2),1,1,'R');//end of line

$perf_val = ($this->inv[0]->co_final_tot/100)*$this->inv[0]->co_profoma;
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'ADVANCE ('.$this->inv[0]->co_profoma.'%)',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($perf_val,2),1,1,'R');//end of line

$balance = ($this->inv[0]->co_final_tot- $perf_val);
$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'BALANCE PAYMENT',0,0);
$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
$this->Cell(28 ,5,number_format($balance,2),1,1,'R');//end of line

$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(12 ,5,'ITEMS: ',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
$this->SetFont('Arial','',8);
$this->Cell(10 ,5,$i,0,0);//end of line
$this->SetFont('Arial','B',8);
$this->Cell(19 ,5,'QUANTITY: ',0,0);//end of line
$this->SetFont('Arial','',8);
$this->Cell(10 ,5,$this->inv[0]->co_tot_qty,0,1);//end of line
//$this->AliasNbPages();
//$this->AddPage();

$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(17 ,5,'REMARKS :',0,0);
$this->SetFont('Arial','',8);
$this->Cell(150 ,5,$this->inv[0]->co_remark,0,1);
//end of line

$this->Ln(3);
$this->SetFont('Arial','',8);

//$this->Cell(150 ,5,'---------------------',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
//$this->Cell(30 ,5,'----------------------',0,1);//end of line
$this->SetFont('Arial','B',8);
$this->Cell(50 ,5,'TERMS & CONDITIONS :',0,1);//end of line
$this->SetFont('Arial','',10);
//$this->Cell(150 ,5,"",0,0);//end of line



$termcat="";
foreach ($this->tm[0] as $ttm)   {
    foreach ($ttm as $tm)   {
        if($tm->tcat_id==$termcat){
            //$this->Ln(3);
            $this->Cell(50 ,5,'',0,0);
            $this->Cell(300 ,5,' : '.$tm->tmdes_des,0,1);
        }else{
            //$this->Ln(2);
            $this->Cell(50 ,5,$tm->tcat_name,0,0);
            //$this->Ln(3);
            $this->Cell(300 ,5,' : '.$tm->tmdes_des,0,1);
        }
    
    $termcat = $tm->tcat_id;
    }
}



//print_r($this->tm[0]->tmdes_des);
//$this->inv[0]->po_tc;
$this->SetFont('Arial','',9);
//$this->Ln(5);
//$this->Cell(153 ,5,'',0,0);//end of line
//$this->Cell(50 ,5,'  Approved',0,1);//end of line
$this->Ln(12);
$this->Cell(80 ,5,'',0,0);//end of line
$this->Cell(70 ,5,'-------------------------',0,0);//end of line
$this->Cell(40 ,5,'-------------------------',0,1);//end of line

$this->Cell(80 ,2,'',0,0);//end of line
$this->Cell(70 ,2,'     Requested by',0,0);//end of line
$this->Cell(40 ,2,'    Authorized By',0,1);//end of line


//$this->Ln(5);
$this->SetFont('Arial','',8);


	}

	public function printPDF () {
				
	
		
	    $this->SetAutoPageBreak(false);
	    $this->AliasNbPages();
	    $this->SetFont("helvetica", "B", 10);
	    //$this->AddPage();
		
		
		
		
		
	    $this->rptDetailData();
			    
	    $this->Output();
  	}
  	
  	private $widths;
	private $aligns;

	function SetWidths($w)
	{
		//Set the array of column widths
		$this->widths=$w;
	}

	function SetAligns($a)
	{
		//Set the array of column alignments
		$this->aligns=$a;
	}

	function Row($data)
	{
		//Calculate the height of the row
		$nb=0;
		for($i=0;$i<count($data);$i++)
			$nb=max($nb,$this->NbLines($this->widths[$i],$data[$i]));
		$h=4*$nb;
		//Issue a page break first if needed
		$this->CheckPageBreak($h);
		//Draw the cells of the row
		for($i=0;$i<count($data);$i++)
		{
			$w=$this->widths[$i];
			$a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
			//Save the current position
			$x=$this->GetX();
			$y=$this->GetY();
			//Draw the border
			$this->Rect($x,$y,$w,$h);
			//Print the text
			$this->MultiCell($w,4,$data[$i],0,$a);
			//Put the position to the right of the cell
			$this->SetXY($x+$w,$y);
		}
		//Go to the next line
		$this->Ln($h);
	}

	function CheckPageBreak($h)
	{
		//If the height h would cause an overflow, add a new page immediately
		if($this->GetY()+$h>$this->PageBreakTrigger)
			
			$this->AddPage($this->CurOrientation);
	
	}

	function NbLines($w,$txt)
	{
		//Computes the number of lines a MultiCell of width w will take
		$cw=&$this->CurrentFont['cw'];
		if($w==0)
			$w=$this->w-$this->rMargin-$this->x;
		$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
		$s=str_replace("\r",'',$txt);
		$nb=strlen($s);
		if($nb>0 and $s[$nb-1]=="\n")
			$nb--;
		$sep=-1;
		$i=0;
		$j=0;
		$l=0;
		$nl=1;
		while($i<$nb)
		{
			$c=$s[$i];
			if($c=="\n")
			{
				$i++;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
				continue;
			}
			if($c==' ')
				$sep=$i;
			$l+=$cw[$c];
			if($l>$wmax)
			{
				if($sep==-1)
				{
					if($i==$j)
						$i++;
				}
				else
					$i=$sep+1;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
			}
			else
				$i++;
		}
		return $nl;
	}
} //end of class


$options = array(
	'inv' => $inv, //nama file penyimpanan, kosongkan jika output ke browser
	'destinationfile' => '', //I=inline browser (default), F=local file, D=download
	'paper_size'=>'F4',	//paper size: F4, A3, A4, A5, Letter, Legal
	'orientation'=>'P' //orientation: P=portrait, L=landscape

);

$tabel = new PDF_sample($data, $options,$inv,$inv_itm,$tm);
//$tabel->printPDF();
$tabel->printPDF();
?>